"""
HCE project, Python bindings, Crawler application.
Fetcher module tests.

@package: dc
@file ftest_dc_fetchers.py
@author bgv <bgv.hce@gmail.com>
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2015 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 1.4.3
"""

from dc_crawler.Fetcher import BaseFetcher
import logging
import os
from app.Utils import varDump

# define a Handler which writes INFO messages or higher to the sys.stderr
console = logging.StreamHandler()
console.setLevel(logging.INFO)
# set a format which is simpler for console use
formatter = logging.Formatter('%(asctime)s - %(thread)ld - %(module)s - %(funcName)s - %(levelname)s - %(message)s')
# tell the handler to use this format
console.setFormatter(formatter)
# add the handler to the root logger
logging.getLogger('').addHandler(console)

logger = logging.getLogger("")


if __name__ == "__main__":
  res = None

  print "CurDir=%s", os.path.dirname(os.path.realpath(__file__))
  hdrs = None
  headersDict = {}
  with open("../../ini/crawler-task_headers.txt", 'r') as f:
    hdrs = ''.join(f.readlines())

  #print hdrs

  for header in hdrs.splitlines():
    if not header:
      continue
    try:
      key, value = header[:header.index(':')].strip(), header[header.index(':') + len(':'):].strip()
    except Exception:
      print "header error:%s", header
    headersDict[key] = value

  print "headersDict:%s", varDump(headersDict)

  #url = "http://127.0.0.1/"
  url = "http://www.afpbb.com/articles/-/3046087"
  httpTimeout = 30000
  allowRedirects = 1
  proxies = None
  authorization = None
  postData = None
  process_content_types = ["text/html"]
  maxResourceSize = 1024 * 1024
  maxHttpRedirects = 3

  try:
    #Test of NORMAL (request lib based) fetcher
    fetchType = 1
    res = BaseFetcher.get_fetcher(fetchType).open(url,
      external_url=None,
      timeout=int(httpTimeout) / 1000.0,
      headers=headersDict,
      allow_redirects=allowRedirects,
      proxies=proxies, auth=authorization,
      data=postData, logger=logger,
      allowed_content_types=process_content_types,
      max_resource_size=maxResourceSize,
      max_redirects=maxHttpRedirects)
  except Exception, err:
    #logger.debug("Exception:\n%s", varDump(err))
    print "Exception:\n%s", varDump(err)

  #logger.debug("Result:\n%s", varDump(res))
  print "Result:\n%s", varDump(res)


  #Test of DYNAMIC (selenium based) fetcher


  #check if all OK
  #assert generalResponse.errorCode == GeneralResponse.ERROR_OK
