/**
 * @file DataNodeOptions.hpp
 *
 * Implementation class DataNodeOptions for HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DATA_NODE_OPTIONS_HPP
#define DATA_NODE_OPTIONS_HPP

#include "Handler.hpp"
#include "HandlerProperties.hpp"

namespace HCE
{
namespace handlers
{
//-----------------------------------------------------------------------------
class DataNodeOptions
{
public:
  DataNodeOptions(HandlerProperties& handlerProperties);
  virtual ~DataNodeOptions(void) {};

  void initNode(const std::string& iniFile, LoggerStream& logger);

  void setHeartbeatDelay(unsigned int heartbeatDelay);
  unsigned int getHeartbeatDelay(void);

  void setHeartbeatTimeout(unsigned int heartbeatTimeout);
  unsigned int getHeartbeatTimeout(void);

  void setHeartbeatMode(unsigned int heartbeatMode);
  unsigned int getHeartbeatMode(void);

private:
  HandlerProperties& properties;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce
} // end namespace HCE 

#endif // DATA_NODE_OPTIONS_HPP
